=== modified file 'NEWS'
--- NEWS	2012-07-09 15:23:26 +0000
+++ NEWS	2011-12-20 16:47:38 +0000
@@ -5,20 +5,6 @@
   * Fix compatibility with newer versions of gir-gtk which don't allow
     None in STRING columns of ListStores. (Jelmer Vernooij)
 
-  * Properly handle popup menus when there is no selected revision in
-    "bzr viz". (Jelmer Vernooij, #281717)
-
-  * Ignore bzr-handle-patch.desktop in sofware center.
-    (Jelmer Vernooij, #854245)
-
-  * Fix searching in tree views. (Jelmer Vernooij, #928301)
-
- CHANGES
-
-  * bzr-notify has been removed, as it was causing regressions
-    on several machines and not particularly useful.
-    (Jelmer Vernooij, #714767, #949798, #998994, #342135, #342136, #394536)
-
 0.103.0	2011-12-11
 
  FEATURES

=== modified file '__init__.py'
--- __init__.py	2012-03-16 17:28:20 +0000
+++ __init__.py	2011-12-19 17:47:22 +0000
@@ -53,6 +53,10 @@
 
 import bzrlib
 import bzrlib.api
+from bzrlib import (
+    branch,
+    config,
+    )
 from bzrlib.commands import plugin_cmds
 
 from bzrlib.plugins.gtk.info import (
@@ -130,30 +134,14 @@
     from bzrlib.plugins.gtk import commitmsgs
     commitmsgs.save_commit_messages(*args)
 
-try:
-    from bzrlib.hooks import install_lazy_named_hook
-except ImportError:
-    from bzrlib.branch import Branch
-    Branch.hooks.install_named_hook('post_uncommit',
-                                    save_commit_messages,
-                                    "Saving commit messages for gcommit")
-else:
-    install_lazy_named_hook("bzrlib.branch", "Branch.hooks",
-        'post_uncommit', save_commit_messages, "Saving commit messages for gcommit")
-
-try:
-    from bzrlib.registry import register_lazy
-except ImportError:
-    from bzrlib import config
-    option_registry = getattr(config, "option_registry", None)
-    if option_registry is not None:
-        config.option_registry.register_lazy('nautilus_integration',
-                'bzrlib.plugins.gtk.config', 'opt_nautilus_integration')
-else:
-    register_lazy("bzrlib.config", "option_registry",
-        'nautilus_integration', 'bzrlib.plugins.gtk.config',
-        'opt_nautilus_integration')
-
+branch.Branch.hooks.install_named_hook('post_uncommit',
+                                       save_commit_messages,
+                                       "Saving commit messages for gcommit")
+
+option_registry = getattr(config, "option_registry", None)
+if option_registry is not None:
+    config.option_registry.register_lazy('nautilus_integration',
+            'bzrlib.plugins.gtk.config', 'opt_nautilus_integration')
 
 def load_tests(basic_tests, module, loader):
     testmod_names = [

=== modified file 'annotate/gannotate.py'
--- annotate/gannotate.py	2012-03-11 18:24:06 +0000
+++ annotate/gannotate.py	2012-02-09 01:56:37 +0000
@@ -27,7 +27,6 @@
 from bzrlib.revision import NULL_REVISION, CURRENT_REVISION
 
 from bzrlib.plugins.gtk.annotate.colormap import AnnotateColorSaturation
-from bzrlib.plugins.gtk.i18n import _i18n
 from bzrlib.plugins.gtk.revisionview import RevisionView
 from bzrlib.plugins.gtk.window import Window
 
@@ -484,7 +483,7 @@
         self.pack_start(entry, False, False, 0)
 
         # Next/previous buttons
-        button = Gtk.Button(_i18n('_Next'), use_underline=True)
+        button = Gtk.Button('_Next')
         image = Gtk.Image()
         image.set_from_stock('gtk-go-forward', Gtk.IconSize.BUTTON)
         button.set_image(image)
@@ -492,7 +491,7 @@
                        'forward')
         self.pack_start(button, False, False, 0)
 
-        button = Gtk.Button(_i18n('_Previous'), use_underline=True)
+        button = Gtk.Button('_Previous')
         image = Gtk.Image()
         image.set_from_stock('gtk-go-back', Gtk.IconSize.BUTTON)
         button.set_image(image)

=== modified file 'branchview/treeview.py'
--- branchview/treeview.py	2012-03-23 15:02:38 +0000
+++ branchview/treeview.py	2011-10-30 08:33:37 +0000
@@ -354,7 +354,7 @@
         # from the key (that is the key is found in a REVNO at the offset 0)
         # or if a MESSAGE *contains* the key anywhere (that is, the key is
         # found case insensitively in a MESSAGE at any offset)
-        def search_equal_func(model, column, key, iter, ignored):
+        def search_equal_func(model, column, key, iter):
             return (model.get_value(iter, treemodel.REVNO).find(key) != 0
                 and model.get_value(iter, treemodel.MESSAGE).lower().find(key.lower()) == -1)
 
@@ -454,11 +454,9 @@
     def _on_revision_selected(self, widget, event):
         from bzrlib.plugins.gtk.revisionmenu import RevisionMenu
         if event.button == 3:
-            revs = []
-            rev = self.get_revision()
-            if rev is not None:
-                revs.append(rev.revision_id)
-            menu = RevisionMenu(self.branch.repository, revs, self.branch)
+            menu = RevisionMenu(self.branch.repository, 
+                [self.get_revision().revision_id],
+                self.branch)
             menu.connect('tag-added', lambda w, t, r: self.add_tag(t, r))
             menu.popup(None, None, None, None, event.button, event.get_time())
 

=== modified file 'bzr-handle-patch'
--- bzr-handle-patch	2012-03-23 12:56:39 +0000
+++ bzr-handle-patch	2012-02-03 22:55:40 +0000
@@ -8,34 +8,34 @@
 import sys
 
 if len(sys.argv) < 2:
-    print "Usage: handle-patch <path>"
-    sys.exit(1)
+	print "Usage: handle-patch <path>"
+	sys.exit(1)
 
 
 path = sys.argv[1]
 
 try:
-    from bzrlib.plugins.gtk.diff import (DiffController,
-                                         MergeDirectiveController)
-    if path == '-':
-        lines = sys.stdin.readlines()
-    else:
-        lines = open(path, 'rb').readlines()
-    lines = [l.replace('\r\n', '\n') for l in lines]
-    try:
-        directive = merge_directive.MergeDirective.from_lines(lines)
-    except errors.NotAMergeDirective:
-        controller = DiffController(path, lines, allow_dirty=True)
-    else:
-        controller = MergeDirectiveController(path, directive)
-    window = controller.window
-    window.show()
-    Gtk = open_display()
-    window.connect("destroy", Gtk.main_quit)
+	from bzrlib.plugins.gtk.diff import (DiffController,
+										 MergeDirectiveController)
+	if path == '-':
+		lines = sys.stdin.readlines()
+	else:
+		lines = open(path, 'rb').readlines()
+	lines = [l.replace('\r\n', '\n') for l in lines]
+	try:
+		directive = merge_directive.MergeDirective.from_lines(lines)
+	except errors.NotAMergeDirective:
+		controller = DiffController(path, lines, allow_dirty=True)
+	else:
+		controller = MergeDirectiveController(path, directive)
+	window = controller.window
+	window.show()
+	Gtk = open_display()
+	window.connect("destroy", Gtk.main_quit)
 except Exception, e:
-    from bzrlib.plugins.gtk.dialog import error_dialog
-    error_dialog('Error', str(e))
-    raise
+	from bzrlib.plugins.gtk.dialog import error_dialog
+	error_dialog('Error', str(e))
+	raise
 
 if len(sys.argv) == 3 and sys.argv[2] == 'test':
     sys.exit(0)

=== modified file 'bzr-handle-patch.desktop'
--- bzr-handle-patch.desktop	2012-03-23 13:45:02 +0000
+++ bzr-handle-patch.desktop	2011-03-06 08:24:07 +0000
@@ -8,4 +8,3 @@
 Type=Application
 Categories=Application;Development;RevisionControl;
 MimeType=text/x-diff;text/x-patch;application/x-bazaar-merge-directive;
-X-AppInstall-Ignore=true

=== added file 'bzr-notify'
--- bzr-notify	1970-01-01 00:00:00 +0000
+++ bzr-notify	2012-02-03 19:49:55 +0000
@@ -0,0 +1,102 @@
+#!/usr/bin/env python
+
+"""Run the bzr tray icon.
+
+This is a background program which will pop up a notification on the users
+screen when a commit occurs.
+"""
+
+from bzrlib.plugin import load_plugins
+load_plugins()
+
+from bzrlib.plugins.gtk.commands import open_display
+
+from bzrlib.plugins.gtk.notify import NotifyPopupMenu
+Gtk = open_display()
+
+import cgi
+import sys
+
+import dbus
+import dbus.service
+from gi.repository import GObject
+from gi.repository import Notify
+
+from bzrlib.bzrdir import BzrDir
+from bzrlib.osutils import format_date
+from bzrlib.transport import get_transport
+
+menu = NotifyPopupMenu()
+try:
+    from gi.repository import AppIndicator3
+except ImportError:
+    icon = Gtk.StatusIcon.new_from_icon_name("bzr-panel")
+    icon.connect('popup-menu', menu.display)
+    icon.set_visible(False)
+    hide_icon = lambda: icon.set_visible(False)
+    show_icon = lambda: icon.set_visible(True)
+else:
+    indicator = AppIndicator3.Indicator.new(
+        "bzr-gtk-notify", "bzr-panel", AppIndicator3.IndicatorCategory.OTHER)
+    indicator.set_status (AppIndicator3.IndicatorStatus.PASSIVE)
+    indicator.set_attention_icon("bzr-panel")
+    indicator.set_menu(menu)
+    hide_icon = lambda: indicator.set_status (
+        AppIndicator3.IndicatorStatus.PASSIVE)
+    show_icon = lambda: indicator.set_status (
+        AppIndicator3.IndicatorStatus.ATTENTION)
+
+if getattr(dbus, 'version', (0,0,0)) >= (0,41,0):
+    import dbus.glib
+BROADCAST_INTERFACE = "org.bazaarvcs.plugins.dbus.Broadcast"
+bus = dbus.SessionBus()
+
+def catch_branch(revision_id, urls):
+    # TODO: show all the urls, or perhaps choose the 'best'.
+    url = urls[0]
+    try:
+        if isinstance(revision_id, unicode):
+            revision_id = revision_id.encode('utf8')
+        transport = get_transport(url)
+        a_dir = BzrDir.open_from_transport(transport)
+        branch = a_dir.open_branch()
+        revno = branch.revision_id_to_revno(revision_id)
+        revision = branch.repository.get_revision(revision_id)
+        summary = 'New revision %d in %s' % (revno, url)
+        body = 'Committer: %s\n' % revision.committer
+        body += 'Date: %s\n' % format_date(revision.timestamp,
+            revision.timezone)
+        body += '\n'
+        body += revision.message
+        body = cgi.escape(body)
+        nw = Notify.Notification.new(summary, body, None)
+        def start_viz(notification=None, action=None, data=None):
+            """Start the viz program."""
+            from bzrlib.plugins.gtk.commands import start_viz_window
+            pp = start_viz_window(branch, revision_id)
+            pp.show()
+        def start_branch(notification=None, action=None, data=None):
+            """Start a Branch dialog"""
+            from bzrlib.plugins.gtk.branch import BranchDialog
+            bd = BranchDialog(remote_path=url)
+            bd.run()
+        if "actions" in Notify.get_server_caps():
+            nw.add_action("inspect", "Inspect", start_viz, None)
+            nw.add_action("branch", "Branch", start_branch, None)
+        show_icon()
+        GObject.timeout_add(5000, hide_icon)
+        nw.set_timeout(5000)
+        nw.show()
+    except Exception, e:
+        print e
+        raise
+bus.add_signal_receiver(catch_branch,
+                        dbus_interface=BROADCAST_INTERFACE,
+                        signal_name="Revision")
+Notify.init("bzr-notify")
+
+if sys.argv[-1] == 'test':
+    # Exit before main loop.
+    sys.exit(0)
+
+Gtk.main()

=== added file 'bzr-notify.desktop'
--- bzr-notify.desktop	1970-01-01 00:00:00 +0000
+++ bzr-notify.desktop	2011-09-28 07:45:39 +0000
@@ -0,0 +1,12 @@
+[Desktop Entry]
+Type=Application
+Version=0.1
+Name=Bazaar Notification
+GenericName=Bazaar Notification
+Comment=Notification Area Icon for Bazaar
+Icon=bzr-icon-64
+Exec=bzr-notify
+Categories=Application;Development;RevisionControl;
+Terminal=false
+X-GNOME-Autostart-Delay=30
+

=== added file 'bzr-notify.desktop.in'
--- bzr-notify.desktop.in	1970-01-01 00:00:00 +0000
+++ bzr-notify.desktop.in	2010-08-21 09:32:13 +0000
@@ -0,0 +1,10 @@
+[Desktop Entry]
+Type=Application
+Version=0.1
+_Name=Bazaar Notification
+_GenericName=Bazaar Notification
+_Comment=Notification Area Icon for Bazaar
+Icon=bzr-icon-64
+Exec=bzr-notify
+Categories=Application;Development;RevisionControl;
+Terminal=false

=== modified file 'commit.py'
--- commit.py	2012-03-22 17:14:22 +0000
+++ commit.py	2012-02-17 15:03:17 +0000
@@ -30,7 +30,6 @@
     tsort,
     )
 from bzrlib.plugins.gtk.dialog import question_dialog
-from bzrlib.plugins.gtk.diff import DiffView
 from bzrlib.plugins.gtk.errors import show_bzr_error
 from bzrlib.plugins.gtk.i18n import _i18n
 from bzrlib.plugins.gtk.commitmsgs import SavedCommitMessagesManager
@@ -289,12 +288,7 @@
             self._check_local.hide()
             return
         if have_dbus:
-            try:
-                bus = dbus.SystemBus()
-            except dbus.DBusException:
-                trace.mutter("DBus system bus not available")
-                self._check_local.show()
-                return
+            bus = dbus.SystemBus()
             try:
                 proxy_obj = bus.get_object('org.freedesktop.NetworkManager',
                                            '/org/freedesktop/NetworkManager')
@@ -560,6 +554,8 @@
                                              Gtk.CellRendererText(), text=3))
 
     def _construct_diff_view(self):
+        from bzrlib.plugins.gtk.diff import DiffView
+
         # TODO: jam 2007-10-30 The diff label is currently disabled. If we
         #       decide that we really don't ever want to display it, we should
         #       actually remove it, and other references to it, along with the
@@ -574,12 +570,6 @@
         self._add_to_right_table(self._diff_view, 4, True)
         self._diff_view.show()
 
-    @staticmethod
-    def get_line_height(widget):
-        pango_layout = widget.create_pango_layout("X");
-        ink_rectangle, logical_rectangle = pango_layout.get_pixel_extents()
-        return logical_rectangle.height
-
     def _construct_file_message(self):
         scroller = Gtk.ScrolledWindow()
         scroller.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
@@ -592,8 +582,6 @@
         self._file_message_text_view.modify_font(Pango.FontDescription("Monospace"))
         self._file_message_text_view.set_wrap_mode(Gtk.WrapMode.WORD)
         self._file_message_text_view.set_accepts_tab(False)
-        line_height = self.get_line_height(self._file_message_text_view)
-        self._file_message_text_view.set_size_request(-1, line_height * 2)
         self._file_message_text_view.show()
 
         self._file_message_expander = Gtk.Expander(

=== modified file 'merge.py'
--- merge.py	2012-03-11 18:24:06 +0000
+++ merge.py	2011-09-08 03:11:06 +0000
@@ -54,7 +54,7 @@
         for entry in [_i18n("Folder"),_i18n("Custom Location")]:
             self._combo_source.append_text(entry)
         self._combo_source.connect("changed", self._on_combo_changed)
-        self._button_merge = Gtk.Button(_i18n("_Merge"), use_underline=True)
+        self._button_merge = Gtk.Button(_i18n("_Merge"))
         self._button_merge_icon = Gtk.Image()
         self._button_merge_icon.set_from_stock(Gtk.STOCK_APPLY, Gtk.IconSize.BUTTON)
         self._button_merge.set_image(self._button_merge_icon)

=== modified file 'nautilus-bzr.py'
--- nautilus-bzr.py	2012-03-05 14:02:16 +0000
+++ nautilus-bzr.py	2011-12-01 10:46:10 +0000
@@ -124,12 +124,6 @@
         dialog.display()
         Gtk.main()
 
-    def push_cb(self, menu, controldir, path=None):
-        from bzrlib.plugins.gtk.push import PushDialog
-        dialog = PushDialog(branch=controldir.open_workingtree().branch)
-        dialog.display()
-        Gtk.main()
-
     def merge_cb(self, menu, tree, path=None):
         from bzrlib.plugins.gtk.merge import MergeDialog
         dialog = MergeDialog(tree, path)
@@ -245,7 +239,6 @@
             item.connect('activate', self.unignore_cb, tree, path)
             yield item
         else:
-            kind = tree.kind(file_id)
             item = Nautilus.MenuItem(name='BzrNautilus::log',
                              label='History ...',
                              tip='List changes',
@@ -275,13 +268,12 @@
             item.connect('activate', self.remove_cb, tree, path)
             yield item
 
-            if kind == 'file':
-                item = Nautilus.MenuItem(name='BzrNautilus::annotate',
-                             label='Annotate ...',
-                             tip='Annotate File Data',
-                             icon='')
-                item.connect('activate', self.annotate_cb, tree, path, file_id)
-                yield item
+            item = Nautilus.MenuItem(name='BzrNautilus::annotate',
+                         label='Annotate ...',
+                         tip='Annotate File Data',
+                         icon='')
+            item.connect('activate', self.annotate_cb, tree, path, file_id)
+            yield item
 
     def get_file_items(self, window, files):
         items = []

=== added file 'notify.py'
--- notify.py	1970-01-01 00:00:00 +0000
+++ notify.py	2012-02-03 18:59:38 +0000
@@ -0,0 +1,104 @@
+# Copyright (C) 2007 by Robert Collins
+#                       Jelmer Vernooij
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+"""Notification area icon and notification for Bazaar."""
+
+from gi.repository import Gtk
+import bzrlib
+
+
+def has_dbus():
+    return (getattr(bzrlib.plugins, "dbus", None) is not None)
+
+
+def has_avahi():
+    return (getattr(bzrlib.plugins, "avahi", None) is not None)
+
+
+class NotifyPopupMenu(Gtk.Menu):
+
+    SHOW_WIDGETS = True
+
+    def __init__(self):
+        super(NotifyPopupMenu, self).__init__()
+        self.create_items()
+
+    def create_items(self):
+        from bzrlib import errors
+        item = Gtk.CheckMenuItem.new_with_mnemonic('_Gateway to LAN')
+        item.connect('toggled', self.toggle_lan_gateway)
+        self.append(item)
+        self.append(Gtk.SeparatorMenuItem())
+        try:
+            from bzrlib.plugins.dbus.activity import LanGateway
+            self.langateway = LanGateway()
+        except ImportError:
+            item.set_sensitive(False)
+        except errors.BzrError:
+            # FIXME: Should only catch errors that indicate a lan-notify
+            # process is already running.
+            item.set_sensitive(False)
+
+        item = Gtk.CheckMenuItem.new_with_mnemonic(
+            'Announce _branches on LAN')
+        item.connect('toggled', self.toggle_announce_branches)
+        self.append(item)
+        self.append(Gtk.SeparatorMenuItem())
+        try:
+            from bzrlib.plugins.avahi.share import ZeroConfServer
+            from bzrlib import urlutils
+            self.zeroconfserver = ZeroConfServer(urlutils.normalize_url('.'))
+        except ImportError:
+            item.set_sensitive(False)
+
+        item = Gtk.ImageMenuItem.new_from_stock(Gtk.STOCK_PREFERENCES, None)
+        item.connect('activate', self.show_preferences)
+        self.append(item)
+        item = Gtk.ImageMenuItem.new_from_stock(Gtk.STOCK_ABOUT, None)
+        item.connect('activate', self.show_about)
+        self.append(item)
+        self.append(Gtk.SeparatorMenuItem())
+        item = Gtk.ImageMenuItem.new_from_stock(Gtk.STOCK_QUIT, None)
+        item.connect('activate', Gtk.main_quit)
+        self.append(item)
+        if self.SHOW_WIDGETS:
+            self.show_all()
+
+    def display(self, icon, event_button, event_time):
+        self.popup(None, None, Gtk.status_icon_position_menu,
+               event_button, event_time, icon)
+
+    def toggle_lan_gateway(self, item):
+        if item.get_active():
+            self.langateway.start()
+        else:
+            self.langateway.stop()
+
+    def toggle_announce_branches(self, item):
+        if item.get_active():
+            self.zeroconfserver.start()
+        else:
+            self.zeroconfserver.close()
+
+    def show_about(self, item):
+        from bzrlib.plugins.gtk.about import AboutDialog
+        dialog = AboutDialog()
+        dialog.run()
+
+    def show_preferences(self, item):
+        from bzrlib.plugins.gtk.preferences import PreferencesWindow
+        prefs = PreferencesWindow()
+        prefs.run()

=== modified file 'po/da.po'
--- po/da.po	2012-03-02 04:30:32 +0000
+++ po/da.po	2011-12-02 05:55:20 +0000
@@ -7,15 +7,15 @@
 msgstr ""
 "Project-Id-Version: bzr-gtk\n"
 "Report-Msgid-Bugs-To: FULL NAME <EMAIL@ADDRESS>\n"
-"POT-Creation-Date: 2011-03-06 02:19+0100\n"
-"PO-Revision-Date: 2012-03-01 17:12+0000\n"
-"Last-Translator: nanker <Unknown>\n"
+"POT-Creation-Date: 2011-12-01 11:46+0100\n"
+"PO-Revision-Date: 2011-11-30 22:59+0000\n"
+"Last-Translator: Launchpad Translations Administrators <Unknown>\n"
 "Language-Team: Danish <da@li.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2012-03-02 04:30+0000\n"
-"X-Generator: Launchpad (build 14886)\n"
+"X-Launchpad-Export-Date: 2011-12-02 05:54+0000\n"
+"X-Generator: Launchpad (build 14414)\n"
 
 #: ../bazaar-properties.desktop.in.h:1
 msgid "Bazaar Preferences"
@@ -31,7 +31,7 @@
 
 #: ../bzr-handle-patch.desktop.in.h:2
 msgid "Bazaar"
-msgstr "Bazaar"
+msgstr ""
 
 #: ../bzr-notify.desktop.in.h:1
 msgid "Bazaar Notification"
@@ -60,11 +60,11 @@
 
 #: ../branch.py:53 ../checkout.py:52
 msgid "Revision:"
-msgstr "Revision:"
+msgstr ""
 
 #: ../branch.py:54 ../checkout.py:47
 msgid "Please select a folder"
-msgstr "Vælg venligst en mappe"
+msgstr ""
 
 #: ../branch.py:134 ../checkout.py:153
 msgid "Missing branch location"
@@ -106,7 +106,7 @@
 
 #: ../commands.py:306
 msgid "Operation aborted."
-msgstr "Operation afbrudt."
+msgstr ""
 
 #: ../commands.py:410
 msgid "There are local changes in the branch"
@@ -122,19 +122,19 @@
 
 #: ../commit.py:179
 msgid "removed"
-msgstr "fjernet"
+msgstr ""
 
 #: ../commit.py:180
 msgid "renamed"
-msgstr "omdøbt"
+msgstr ""
 
 #: ../commit.py:181
 msgid "renamed and modified"
-msgstr "omdøbt og ændret"
+msgstr ""
 
 #: ../commit.py:182
 msgid "modified"
-msgstr "ændret"
+msgstr ""
 
 #: ../commit.py:183
 msgid "kind changed"
@@ -178,7 +178,7 @@
 
 #: ../commit.py:443 ../conflicts.py:107
 msgid "Path"
-msgstr "Sti"
+msgstr ""
 
 #: ../commit.py:445 ../conflicts.py:109
 msgid "Type"
@@ -194,7 +194,7 @@
 
 #: ../commit.py:503
 msgid "Date"
-msgstr "Dato"
+msgstr ""
 
 #: ../commit.py:505
 msgid "Committer"
@@ -202,7 +202,7 @@
 
 #: ../commit.py:507 ../search.py:60
 msgid "Summary"
-msgstr "Oversigt"
+msgstr ""
 
 #. TODO: jam 2007-10-30 The diff label is currently disabled. If we
 #. decide that we really don't ever want to display it, we should
@@ -272,7 +272,7 @@
 
 #: ../conflicts.py:97
 msgid "Conflicts"
-msgstr "Konflikter"
+msgstr ""
 
 #: ../conflicts.py:100
 msgid "No conflicts in working tree."
@@ -316,7 +316,7 @@
 
 #: ../conflicts.py:132
 msgid "unknown type of conflict"
-msgstr "ukendt type af konflikt"
+msgstr ""
 
 #: ../conflicts.py:161
 msgid "No file was selected"
@@ -324,7 +324,7 @@
 
 #: ../conflicts.py:162
 msgid "Please select a file from the list."
-msgstr "Vælg venligst en fil fra listen."
+msgstr ""
 
 #: ../conflicts.py:172
 msgid "Call to external utility failed"
@@ -332,7 +332,7 @@
 
 #: ../conflicts.py:174
 msgid "Cannot resolve conflict"
-msgstr "Kan ikke løse konflikt"
+msgstr ""
 
 #: ../conflicts.py:175
 msgid ""
@@ -569,6 +569,46 @@
 msgid "Bazaar command error"
 msgstr ""
 
+#: ../nautilus-bzr.py:460
+msgid "File id:"
+msgstr ""
+
+#: ../nautilus-bzr.py:463
+msgid "SHA1Sum:"
+msgstr ""
+
+#: ../nautilus-bzr.py:469
+msgid "Last Change Revision:"
+msgstr ""
+
+#: ../nautilus-bzr.py:474
+msgid "Last Change Author:"
+msgstr ""
+
+#: ../nautilus-bzr.py:515
+msgid "Push location:"
+msgstr ""
+
+#: ../nautilus-bzr.py:518
+msgid "Parent location:"
+msgstr ""
+
+#: ../nautilus-bzr.py:521
+msgid "Bound location:"
+msgstr ""
+
+#: ../nautilus-bzr.py:524
+msgid "Public location:"
+msgstr ""
+
+#: ../nautilus-bzr.py:527
+msgid "Submit location:"
+msgstr ""
+
+#: ../nautilus-bzr.py:530
+msgid "Append revisions only"
+msgstr ""
+
 #. Create the widgets
 #: ../push.py:50
 msgid "Location:"

=== modified file 'po/de.po'
--- po/de.po	2012-01-01 05:55:28 +0000
+++ po/de.po	2011-12-02 05:55:20 +0000
@@ -8,34 +8,34 @@
 "Project-Id-Version: olive\n"
 "Report-Msgid-Bugs-To: FULL NAME <EMAIL@ADDRESS>\n"
 "POT-Creation-Date: 2011-12-01 11:46+0100\n"
-"PO-Revision-Date: 2011-12-31 16:09+0000\n"
-"Last-Translator: Daniel Winzen <d@winzen4.de>\n"
+"PO-Revision-Date: 2011-11-30 22:58+0000\n"
+"Last-Translator: Jelmer Vernooij <Unknown>\n"
 "Language-Team: German <de@li.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2012-01-01 05:55+0000\n"
-"X-Generator: Launchpad (build 14560)\n"
+"X-Launchpad-Export-Date: 2011-12-02 05:55+0000\n"
+"X-Generator: Launchpad (build 14414)\n"
 
 #: ../bazaar-properties.desktop.in.h:1
 msgid "Bazaar Preferences"
-msgstr "Bazaar-Einstellungen"
+msgstr ""
 
 #: ../bazaar-properties.desktop.in.h:2
 msgid "Configure Bazaar settings"
-msgstr "Bazaar-Einstellungen konfigurieren"
+msgstr ""
 
 #: ../bzr-handle-patch.desktop.in.h:1
 msgid "Apply Bazaar Bundle"
-msgstr "Bazaarpaket anwenden"
+msgstr ""
 
 #: ../bzr-handle-patch.desktop.in.h:2
 msgid "Bazaar"
-msgstr "Bazaar"
+msgstr ""
 
 #: ../bzr-notify.desktop.in.h:1
 msgid "Bazaar Notification"
-msgstr "Bazaar-Benachrichtigungen"
+msgstr ""
 
 #: ../bzr-notify.desktop.in.h:2
 msgid "Notification Area Icon for Bazaar"
@@ -154,7 +154,7 @@
 
 #: ../commit.py:388
 msgid "Files"
-msgstr "Dateien"
+msgstr ""
 
 #: ../commit.py:393
 msgid "Commit all changes"
@@ -672,11 +672,11 @@
 
 #: ../search.py:41
 msgid "Search for:"
-msgstr "Suche nach:"
+msgstr ""
 
 #: ../search.py:56
 msgid "Document"
-msgstr "Dokument"
+msgstr ""
 
 #: ../status.py:87
 msgid "Added"

=== modified file 'po/ja.po'
--- po/ja.po	2012-02-12 05:08:39 +0000
+++ po/ja.po	2011-12-02 05:55:20 +0000
@@ -8,18 +8,18 @@
 "Project-Id-Version: bzr-gtk\n"
 "Report-Msgid-Bugs-To: FULL NAME <EMAIL@ADDRESS>\n"
 "POT-Creation-Date: 2011-12-01 11:46+0100\n"
-"PO-Revision-Date: 2012-02-11 12:20+0000\n"
-"Last-Translator: Koichi Akabe <vbkaisetsu@gmail.com>\n"
+"PO-Revision-Date: 2011-11-30 23:01+0000\n"
+"Last-Translator: Fumihito YOSHIDA <hito@kugutsu.org>\n"
 "Language-Team: Japanese <ja@li.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2012-02-12 05:08+0000\n"
-"X-Generator: Launchpad (build 14771)\n"
+"X-Launchpad-Export-Date: 2011-12-02 05:55+0000\n"
+"X-Generator: Launchpad (build 14414)\n"
 
 #: ../bazaar-properties.desktop.in.h:1
 msgid "Bazaar Preferences"
-msgstr "Bazaar 設定"
+msgstr ""
 
 #: ../bazaar-properties.desktop.in.h:2
 msgid "Configure Bazaar settings"
@@ -31,11 +31,11 @@
 
 #: ../bzr-handle-patch.desktop.in.h:2
 msgid "Bazaar"
-msgstr "Bazaar"
+msgstr ""
 
 #: ../bzr-notify.desktop.in.h:1
 msgid "Bazaar Notification"
-msgstr "Bazaar 通知"
+msgstr ""
 
 #: ../bzr-notify.desktop.in.h:2
 msgid "Notification Area Icon for Bazaar"
@@ -142,7 +142,7 @@
 
 #: ../commit.py:276
 msgid "<b>Commit Message</b>"
-msgstr "<b>コミットメッセージ</b>"
+msgstr ""
 
 #: ../commit.py:329
 msgid "_Only commit locally"
@@ -158,11 +158,11 @@
 
 #: ../commit.py:393
 msgid "Commit all changes"
-msgstr "すべての変更をコミット"
+msgstr ""
 
 #: ../commit.py:399
 msgid "Only commit selected changes"
-msgstr "選択した変更のみコミット"
+msgstr ""
 
 #: ../commit.py:405
 msgid "Commit all changes*"
@@ -247,7 +247,7 @@
 
 #: ../commit.py:707
 msgid "You can describe your commit intent in the message."
-msgstr "コミット内容をメッセージで説明できます。"
+msgstr ""
 
 #: ../commit.py:727
 msgid "Commit with unknowns?"

=== modified file 'po/sv.po'
--- po/sv.po	2012-02-22 06:51:43 +0000
+++ po/sv.po	2011-12-02 05:55:20 +0000
@@ -8,14 +8,14 @@
 "Project-Id-Version: olive\n"
 "Report-Msgid-Bugs-To: FULL NAME <EMAIL@ADDRESS>\n"
 "POT-Creation-Date: 2011-12-01 11:46+0100\n"
-"PO-Revision-Date: 2012-02-21 16:04+0000\n"
-"Last-Translator: Rikard Edgren <Unknown>\n"
+"PO-Revision-Date: 2011-11-30 22:59+0000\n"
+"Last-Translator: Daniel Nylander <yeager@ubuntu.com>\n"
 "Language-Team: Swedish <sv@li.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Launchpad-Export-Date: 2012-02-22 06:51+0000\n"
-"X-Generator: Launchpad (build 14838)\n"
+"X-Launchpad-Export-Date: 2011-12-02 05:55+0000\n"
+"X-Generator: Launchpad (build 14414)\n"
 
 #: ../bazaar-properties.desktop.in.h:1
 msgid "Bazaar Preferences"
@@ -48,7 +48,7 @@
 
 #: ../branch.py:49 ../checkout.py:49
 msgid "Branch location:"
-msgstr "Grenens plats:"
+msgstr ""
 
 #: ../branch.py:51 ../checkout.py:50
 msgid "Destination:"
@@ -56,11 +56,11 @@
 
 #: ../branch.py:52
 msgid "Branck nick:"
-msgstr "Grenens kortnamn:"
+msgstr ""
 
 #: ../branch.py:53 ../checkout.py:52
 msgid "Revision:"
-msgstr "Version:"
+msgstr "Revision:"
 
 #: ../branch.py:54 ../checkout.py:47
 msgid "Please select a folder"
@@ -68,29 +68,29 @@
 
 #: ../branch.py:134 ../checkout.py:153
 msgid "Missing branch location"
-msgstr "Grenens plats saknas"
+msgstr ""
 
 #: ../branch.py:135 ../checkout.py:154
 msgid "You must specify a branch location."
-msgstr "Du måste ange en plats för grenen."
+msgstr ""
 
 #: ../branch.py:174
 msgid "Branching successful"
-msgstr "Förgrening lyckades"
+msgstr "Grening lyckades"
 
 #: ../branch.py:175
 #, python-format
 msgid "%d revision(s) branched."
-msgstr "%d version(er) förgrenade."
+msgstr "%d revision(er) grenade."
 
 #: ../branch.py:183 ../checkout.py:185
 msgid "N/A"
-msgstr "Inte tillgänglig"
+msgstr ""
 
 #. Create the widgets
 #: ../checkout.py:44
 msgid "Check_out"
-msgstr "Checka_ut"
+msgstr ""
 
 #: ../checkout.py:51
 msgid "Branch nick:"
@@ -98,15 +98,15 @@
 
 #: ../checkout.py:56
 msgid "_Lightweight checkout"
-msgstr "_Lätt utcheckning"
+msgstr ""
 
 #: ../commands.py:305
 msgid "Directory does not have a working tree"
-msgstr "Katalogen innehåller inte något arbetsträd"
+msgstr "Katalogen innehåller inte ett arbetsträd"
 
 #: ../commands.py:306
 msgid "Operation aborted."
-msgstr "Åtgärden avbröts."
+msgstr "Åtgärden avbruten."
 
 #: ../commands.py:410
 msgid "There are local changes in the branch"
@@ -130,7 +130,7 @@
 
 #: ../commit.py:181
 msgid "renamed and modified"
-msgstr "omdöpt och ändrad"
+msgstr ""
 
 #: ../commit.py:182
 msgid "modified"
@@ -268,39 +268,39 @@
 
 #: ../conflicts.py:45
 msgid "External utility:"
-msgstr "Externt verktyg:"
+msgstr ""
 
 #: ../conflicts.py:97
 msgid "Conflicts"
-msgstr "Konflikter"
+msgstr ""
 
 #: ../conflicts.py:100
 msgid "No conflicts in working tree."
-msgstr "Inga konflikter i arbetsträd."
+msgstr ""
 
 #: ../conflicts.py:114
 msgid "path conflict"
-msgstr "sökvägskonflikt"
+msgstr ""
 
 #: ../conflicts.py:116
 msgid "contents conflict"
-msgstr "innehållskonflikt"
+msgstr ""
 
 #: ../conflicts.py:118
 msgid "text conflict"
-msgstr "textkonflikt"
+msgstr ""
 
 #: ../conflicts.py:120
 msgid "duplicate id"
-msgstr "duplicera id"
+msgstr ""
 
 #: ../conflicts.py:122
 msgid "duplicate"
-msgstr "duplicera"
+msgstr ""
 
 #: ../conflicts.py:124
 msgid "parent loop"
-msgstr "överordnad loop"
+msgstr ""
 
 #: ../conflicts.py:126
 msgid "unversioned parent"
@@ -316,7 +316,7 @@
 
 #: ../conflicts.py:132
 msgid "unknown type of conflict"
-msgstr "okänd konflikttyp"
+msgstr ""
 
 #: ../conflicts.py:161
 msgid "No file was selected"
@@ -324,15 +324,15 @@
 
 #: ../conflicts.py:162
 msgid "Please select a file from the list."
-msgstr "Välj en fil från listan."
+msgstr ""
 
 #: ../conflicts.py:172
 msgid "Call to external utility failed"
-msgstr "Anrop till externt verktyg misslyckades"
+msgstr ""
 
 #: ../conflicts.py:174
 msgid "Cannot resolve conflict"
-msgstr "Kan inte lösa konflikt"
+msgstr ""
 
 #: ../conflicts.py:175
 msgid ""
@@ -353,16 +353,16 @@
 #. No conflicts found.
 #: ../diff.py:493 ../merge.py:144
 msgid "Merge successful"
-msgstr "Sammanslagningen lyckades"
+msgstr ""
 
 #: ../diff.py:494 ../merge.py:145
 msgid "All changes applied successfully."
-msgstr "Alla ändringar har aktiverats utan problem."
+msgstr ""
 
 #. There are conflicts to be resolved.
 #: ../diff.py:497 ../merge.py:148
 msgid "Conflicts encountered"
-msgstr "Konflikter uppkom."
+msgstr ""
 
 #: ../diff.py:498 ../merge.py:149
 msgid "Please resolve the conflicts manually before committing."
@@ -374,7 +374,7 @@
 
 #: ../errors.py:32
 msgid "You can perform this action only in a branch."
-msgstr "Du kan endast genomföra denna operation i en gren."
+msgstr ""
 
 #: ../errors.py:34
 msgid "Directory is not a checkout"
@@ -417,8 +417,6 @@
 "There are unknown files in the working tree.\n"
 "Please add or delete them."
 msgstr ""
-"Det finns okända filer i arbetsträdet.\n"
-"Lägg till eller radera dem."
 
 #: ../errors.py:49
 msgid "Bound branch is out of date"
@@ -450,7 +448,7 @@
 
 #: ../errors.py:59
 msgid "No diff output"
-msgstr "Ingen utdata från diff"
+msgstr ""
 
 #: ../errors.py:60
 msgid "The selected file hasn't changed."
@@ -458,7 +456,7 @@
 
 #: ../errors.py:62
 msgid "No such revision"
-msgstr "Ingen sådan version"
+msgstr ""
 
 #: ../errors.py:63
 msgid "The revision you specified doesn't exist."
@@ -470,7 +468,7 @@
 
 #: ../errors.py:66
 msgid "Target directory already exists. Please select another target."
-msgstr "Målkatalogen existerar redan. Välj ett annat mål."
+msgstr ""
 
 #: ../errors.py:68
 msgid "Directory is already a branch"
@@ -482,12 +480,10 @@
 "The current directory (%s) is already a branch.\n"
 "You can start using it, or initialize another directory."
 msgstr ""
-"Den aktuella katalogen (%s) är redan en gren.\n"
-"Du kan börja använda den, eller initiera en ny katalog."
 
 #: ../errors.py:71
 msgid "Branch without a working tree"
-msgstr "Gren utan arbetsträd"
+msgstr ""
 
 #: ../errors.py:72
 #, python-format
@@ -495,12 +491,10 @@
 "The current directory (%s)\n"
 "is a branch without a working tree."
 msgstr ""
-"Den nuvarande katalogen (%s)\n"
-"är en gren utan arbetsträd."
 
 #: ../errors.py:74
 msgid "Unknown bzr error"
-msgstr "Okänt bzr-fel"
+msgstr ""
 
 #: ../errors.py:76
 msgid "Permission denied"
@@ -508,7 +502,7 @@
 
 #: ../errors.py:76
 msgid "permission denied."
-msgstr "åtkomst nekad."
+msgstr ""
 
 #: ../errors.py:78
 msgid "Unknown error"
@@ -521,23 +515,23 @@
 
 #: ../initialize.py:47
 msgid "Which directory do you want to initialize?"
-msgstr "Vilken mapp vill du initalisera?"
+msgstr ""
 
 #: ../initialize.py:49
 msgid "Current directory"
-msgstr "Nuvarande katalog"
+msgstr ""
 
 #: ../initialize.py:51
 msgid "Create a new directory with the name:"
-msgstr "Skapa en ny katalog med namnet:"
+msgstr ""
 
 #: ../initialize.py:87
 msgid "Directory name not specified"
-msgstr "Katalognamn ej specificerat"
+msgstr ""
 
 #: ../initialize.py:88
 msgid "You should specify a new directory name."
-msgstr "Du bör specificera ett nytt katalognamn."
+msgstr ""
 
 #: ../loom.py:49
 msgid "Upgrade to Loom branch?"
@@ -569,11 +563,11 @@
 
 #: ../merge.py:131
 msgid "Please specify a branch to merge from."
-msgstr "Ange en gren att slå samman med."
+msgstr ""
 
 #: ../merge.py:139
 msgid "Bazaar command error"
-msgstr "Bazaar kommando-fel"
+msgstr ""
 
 #: ../nautilus-bzr.py:460
 msgid "File id:"
@@ -641,7 +635,7 @@
 
 #: ../push.py:141
 msgid "Non existing parent directory"
-msgstr "Ingen existerande överordnad katalog"
+msgstr ""
 
 #: ../push.py:142
 #, python-format
@@ -690,23 +684,23 @@
 #. Set properties
 #: ../tags.py:60
 msgid "Tags"
-msgstr "Etiketter"
+msgstr ""
 
 #: ../tags.py:110
 msgid "Tag Name"
-msgstr "Etikett-namn"
+msgstr ""
 
 #: ../tags.py:115
 msgid "Revision ID"
-msgstr "Versions-ID"
+msgstr ""
 
 #: ../tags.py:148
 msgid "Tags are not supported by this branch format. Please upgrade."
-msgstr "Etiketter stöds ej i detta gren-format. Vänligen uppgradera."
+msgstr ""
 
 #: ../tags.py:154
 msgid "No tagged revisions in the branch."
-msgstr "Inga versioner med etiketter i denna gren."
+msgstr ""
 
 #: ../tags.py:222
 msgid "_Remove tag"
@@ -732,7 +726,7 @@
 
 #: ../tags.py:281
 msgid "Revision ID:"
-msgstr "Versions-ID:"
+msgstr ""
 
 #: ../tags.py:312
 msgid "No tag name specified"

=== modified file 'push.py'
--- push.py	2012-03-11 21:41:49 +0000
+++ push.py	2012-03-04 01:47:01 +0000
@@ -24,8 +24,7 @@
     errors,
     ui,
     )
-from bzrlib.controldir import ControlDir
-from bzrlib.push import PushResult
+from bzrlib.bzrdir import BzrDir
 from bzrlib.transport import get_transport
 
 from bzrlib.plugins.gtk.dialog import (
@@ -39,19 +38,15 @@
 class PushDialog(Gtk.Dialog):
     """New implementation of the Push dialog."""
 
-    def __init__(self, repository=None, revid=None, branch=None, parent=None):
+    def __init__(self, repository, revid, branch=None, parent=None):
         """Initialize the Push dialog. """
         super(PushDialog, self).__init__(
             title="Push", parent=parent, flags=0, border_width=6,
             buttons=(Gtk.STOCK_CLOSE, Gtk.ResponseType.CLOSE))
-        if repository is None:
-            repository = branch.repository
         self.branch = branch
 
         # Unused arguments
         self.repository = repository
-        if revid is None:
-            revid = branch.last_revision()
         self.revid = revid
 
         # Create the widgets
@@ -141,62 +136,43 @@
     :param overwrite: overwrite target location if it diverged
     :return: number of revisions pushed
     """
-    revision_id = None
-    to_transport = get_transport(location)
+    transport = get_transport(location)
+    location_url = transport.base
+
     try:
-        dir_to = ControlDir.open_from_transport(to_transport)
+        dir_to = BzrDir.open(location_url)
+        br_to = dir_to.open_branch()
     except errors.NotBranchError:
-        dir_to = None
-
-    if dir_to is None:
+        # create a branch.
+        transport = transport.clone('..')
         try:
-            br_to = br_from.create_clone_on_transport(
-                to_transport, revision_id=revision_id)
+            relurl = transport.relpath(location_url)
+            transport.mkdir(relurl)
         except errors.NoSuchFile:
             response = question_dialog(
                 _i18n('Non existing parent directory'),
                 _i18n("The parent directory (%s)\ndoesn't exist. Create?") %
-                    location)
+                location)
             if response == Gtk.ResponseType.OK:
-                br_to = br_from.create_clone_on_transport(
-                    to_transport, revision_id=revision_id, create_prefix=True)
+                transport.create_prefix()
             else:
-                return _i18n("Push aborted.")
-        push_result = create_push_result(br_from, br_to)
+                return
+        dir_to = br_from.bzrdir.clone(location_url,
+            revision_id=br_from.last_revision())
+        br_to = dir_to.open_branch()
+        count = len(br_to.revision_history())
     else:
-        push_result = dir_to.push_branch(br_from, revision_id, overwrite)
-    message = create_push_message(br_from, push_result)
-    return message
-
-
-def create_push_message(br_from, push_result):
-    """Return a mesage explaining what happened during the push."""
-    messages = []
-    rev_count = br_from.revno() - push_result.old_revno
-    messages.append(_i18n("%d revision(s) pushed.") % rev_count)
-    if push_result.stacked_on is not None:
-        messages.append(_i18n("Stacked on %s.") % push_result.stacked_on)
-    if push_result.workingtree_updated is False:
-        messages.append(_i18n(
-            "\nThe working tree was not updated:"
-            "\nSee 'bzr help working-trees' for more information."))
-    return '\n'.join(messages)
-
-
-def create_push_result(br_from, br_to):
-    """Return a PushResult like one created by ControlDir.push_branch()."""
-    push_result = PushResult()
-    push_result.source_branch = br_from
-    push_result.target_branch = br_to
-    push_result.branch_push_result = None
-    push_result.master_branch = None
-    push_result.old_revno = 0
-    push_result.old_revid = br_to.last_revision()
-    push_result.workingtree_updated = None  # Not applicable to this case.
-    try:
-        push_result.stacked_on = br_to.get_stacked_on_url()
-    except (errors.UnstackableBranchFormat,
-            errors.UnstackableRepositoryFormat,
-            errors.NotStacked):
-        push_result.stacked_on = None
-    return push_result
+        br_to.revision_history()
+        try:
+            tree_to = dir_to.open_workingtree()
+        except errors.NotLocalUrl:
+            # FIXME - what to do here? how should we warn the user?
+            count = br_to.pull(br_from, overwrite)
+        except errors.NoWorkingTree:
+            count = br_to.pull(br_from, overwrite)
+        else:
+            count = tree_to.pull(br_from, overwrite)
+
+    # The count var is either an int or a PushResult. PushResult is being
+    # coerced into an int, but the method is deprecatedx
+    return _i18n("%d revision(s) pushed.") % int(count)

=== modified file 'setup.py'
--- setup.py	2012-07-09 15:23:26 +0000
+++ setup.py	2012-02-28 17:45:56 +0000
@@ -148,7 +148,7 @@
         maintainer_email="jelmer@samba.org",
         description="GTK+ Frontends for various Bazaar commands",
         license="GNU GPL v2 or later",
-        scripts=['bzr-handle-patch'],
+        scripts=['bzr-handle-patch', 'bzr-notify'],
         url="http://bazaar-vcs.org/BzrGtk",
         package_dir={
             "bzrlib.plugins.gtk": ".",
@@ -188,7 +188,8 @@
                     # In case Python distutils extra is not available,
                     # install the .desktop files
                     ('share/applications', ['bazaar-properties.desktop',
-                                            'bzr-handle-patch.desktop']),
+                                            'bzr-handle-patch.desktop',
+                                            'bzr-notify.desktop']),
                     ('share/application-registry', ['bzr-gtk.applications']),
                     ('share/pixmaps', ['icons/bzr-icon-64.png']),
                     ('share/icons/hicolor/scalable/apps',

=== modified file 'tests/test_commit.py'
--- tests/test_commit.py	2012-03-22 17:14:22 +0000
+++ tests/test_commit.py	2012-02-17 15:03:17 +0000
@@ -235,13 +235,6 @@
         dlg._on_treeview_files_cursor_changed(treeview)
         self.assertFalse(CommitDialogNoWidgets._update_per_file_info.called)
 
-    def test_get_line_height(self):
-        tree = self.make_branch_and_tree('tree')
-        dlg = CommitDialogNoWidgets(tree)
-        textview = Gtk.TextView()
-        line_height = dlg.get_line_height(textview)
-        self.assertIsInstance(line_height, int)
-
 
 class TestCommitDialog(tests.TestCaseWithTransport):
 

=== modified file 'tests/test_push.py'
--- tests/test_push.py	2012-03-20 12:39:08 +0000
+++ tests/test_push.py	2012-03-04 01:54:22 +0000
@@ -45,8 +45,8 @@
         dialog = push.PushDialog(
             repository=None, revid=None, branch=branch, parent=None)
         self.assertIs(None, dialog.props.parent)
-        self.assertIs(branch.repository, dialog.repository)
-        self.assertIs(branch.last_revision(), dialog.revid)
+        self.assertIs(None, dialog.repository)
+        self.assertIs(None, dialog.revid)
         self.assertIs(branch, dialog.branch)
         # Layout rules to match HIG.
         self.assertIsInstance(dialog._label_location, Gtk.Label)
@@ -133,98 +133,3 @@
             (branch, 'lp:~user/fnord/test'), push.do_push.args)
         self.assertEqual(
             {'overwrite': True}, push.do_push.kwargs)
-
-
-class DoPushTestCase(tests.TestCaseWithTransport):
-
-    def setup_ui(self):
-        set_ui_factory()
-        progress_panel = ProgressPanel()
-        ui.ui_factory.set_progress_bar_widget(progress_panel)
-        MockMethod.bind(self, progress_panel.pb, 'tick')
-        MockMethod.bind(self, progress_panel.pb, 'update')
-        MockMethod.bind(self, progress_panel.pb, 'finished')
-        return progress_panel
-
-    def make_from_branch(self):
-        from_tree = self.make_branch_and_tree('this')
-        self.build_tree(['this/a', 'this/b'])
-        from_tree.add(['a', 'b'])
-        from_tree.commit("msg")
-        return from_tree.branch
-
-    def test_do_push_without_dir(self):
-        progress_panel = self.setup_ui()
-        from_branch = self.make_from_branch()
-        message = push.do_push(from_branch, 'that', False)
-        self.assertEqual('1 revision(s) pushed.', message)
-        self.assertEqual(True, progress_panel.pb.update.called)
-        self.assertEqual(True, progress_panel.pb.finished.called)
-
-    def test_do_push_without_parent_dir(self):
-        progress_panel = self.setup_ui()
-        from_branch = self.make_from_branch()
-        MockMethod.bind(self, push, 'question_dialog', Gtk.ResponseType.OK)
-        message = push.do_push(from_branch, 'that/there', False)
-        self.assertEqual('1 revision(s) pushed.', message)
-        self.assertEqual(True, push.question_dialog.called)
-        self.assertEqual(True, progress_panel.pb.update.called)
-        self.assertEqual(True, progress_panel.pb.finished.called)
-
-    def test_do_push_without_parent_dir_aborted(self):
-        self.setup_ui()
-        from_branch = self.make_from_branch()
-        MockMethod.bind(self, push, 'question_dialog', Gtk.ResponseType.CANCEL)
-        message = push.do_push(from_branch, 'that/there', False)
-        self.assertEqual('Push aborted.', message)
-
-    def test_do_push_with_dir(self):
-        progress_panel = self.setup_ui()
-        self.make_branch_and_tree('that')
-        from_branch = self.make_from_branch()
-        message = push.do_push(from_branch, 'that', False)
-        self.assertEqual('1 revision(s) pushed.', message)
-        self.assertEqual(True, progress_panel.pb.update.called)
-        self.assertEqual(True, progress_panel.pb.finished.called)
-
-    def test_create_push_result_unstacked(self):
-        from_branch = object()
-        to_branch = self.make_branch_and_tree('that').branch
-        push_result = push.create_push_result(from_branch, to_branch)
-        self.assertIs(from_branch, push_result.source_branch)
-        self.assertIs(to_branch, push_result.target_branch)
-        self.assertIs(None, push_result.branch_push_result)
-        self.assertIs(None, push_result.master_branch)
-        self.assertEqual(0, push_result.old_revno)
-        self.assertEqual(to_branch.last_revision(), push_result.old_revid)
-        self.assertIs(None, push_result.workingtree_updated)
-        self.assertIs(None, push_result.stacked_on)
-
-    def test_create_push_result_stacked(self):
-        from_branch = object()
-        to_branch = self.make_branch_and_tree('that').branch
-        MockMethod.bind(self, to_branch, 'get_stacked_on_url', 'lp:project')
-        push_result = push.create_push_result(from_branch, to_branch)
-        self.assertEqual('lp:project', push_result.stacked_on)
-
-    def test_create_push_message_stacked_on(self):
-        from_branch = object()
-        to_branch = self.make_branch_and_tree('that').branch
-        MockMethod.bind(self, to_branch, 'get_stacked_on_url', 'lp:project')
-        push_result = push.create_push_result(from_branch, to_branch)
-        from_branch = self.make_from_branch()
-        message = push.create_push_message(from_branch, push_result)
-        self.assertEqual(
-            '1 revision(s) pushed.\nStacked on lp:project.', message)
-
-    def test_create_push_message_workingtree_updated_false(self):
-        from_branch = object()
-        to_branch = self.make_branch_and_tree('that').branch
-        push_result = push.create_push_result(from_branch, to_branch)
-        push_result.workingtree_updated = False
-        from_branch = self.make_from_branch()
-        message = push.create_push_message(from_branch, push_result)
-        self.assertEqual(
-            "1 revision(s) pushed.\n\nThe working tree was not updated:\n"
-            "See 'bzr help working-trees' for more information.",
-            message)

=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2012-03-01 21:29:00 +0000
+++ viz/branchwin.py	2012-02-09 04:11:54 +0000
@@ -478,10 +478,7 @@
         else:
             parent_id = parents[0]
 
-        if revision is not None:
-            self.show_diff(revision.revision_id, parent_id)
-        else:
-            self.show_diff(NULL_REVISION)
+        self.show_diff(revision.revision_id, parent_id)
         self.treeview.grab_focus()
 
     def _back_clicked_cb(self, *args):
@@ -657,7 +654,7 @@
             return width, height
         return None
 
-    def show_diff(self, revid, parentid=NULL_REVISION):
+    def show_diff(self, revid=None, parentid=NULL_REVISION):
         """Open a new window to show a diff between the given revisions."""
         from bzrlib.plugins.gtk.diff import DiffWindow
         window = DiffWindow(parent=self)

